Bug 2226670

Summary: Review Request: corrade - C++11 multiplatform utility library
Product: [Fedora] Fedora Reporter: Felix Wang <topazus>
Component: Package ReviewAssignee: Petr Menšík <pemensik>
Status: ASSIGNED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: package-review, pemensik
Target Milestone: ---Flags: pemensik: fedora-review?
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:

Description Felix Wang 2023-07-26 07:45:39 UTC
Spec URL: https://topazus.fedorapeople.org/rpms/corrade.spec
SRPM URL: https://topazus.fedorapeople.org/rpms/corrade-2020.6-1.20230725gitb2be50e.fc39.src.rpm
Description:
Corrade is a multiplatform utility library written in C++11/C++14. It's used as
a base for the Magnum graphics engine, among other things.

Fedora Account System Username: topazus

koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=103933869

Comment 1 Petr Menšík 2023-10-31 21:05:28 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* The
     Unlicense", "*No copyright* MIT License", "The Unlicense MIT License",
     "*No copyright* [generated file]". 272 files have unknown license.
     Detailed output of licensecheck in
     /home/pemensik/fedora/rawhide/2226670-corrade/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/corrade/debuggers/gdb,
     /usr/share/corrade/debuggers
[!]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/corrade/debuggers/gdb, /usr/share/corrade/debuggers
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 13370 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: corrade-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
          corrade-devel-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
          corrade-debuginfo-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
          corrade-debugsource-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
          corrade-2020.6-1.20230725gitb2be50e.fc40.src.rpm
============================================================== rpmlint session starts =============================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp1fs3fhjc')]
checks: 31, packages: 5

corrade-devel.x86_64: W: no-manual-page-for-binary corrade-rc
corrade-devel.x86_64: W: no-documentation
=============================== 5 packages and 0 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 0.8 s ==============================




Rpmlint (debuginfo)
-------------------
Checking: corrade-debuginfo-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
          corrade-devel-debuginfo-2020.6-1.20230725gitb2be50e.fc40.x86_64.rpm
============================================================== rpmlint session starts =============================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpoimpla6f')]
checks: 31, packages: 2

=============================== 2 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.4 s ==============================





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 5

corrade-devel.x86_64: W: no-manual-page-for-binary corrade-rc
corrade-devel.x86_64: W: no-documentation
 5 packages and 0 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 1.6 s 



Source checksums
----------------
https://github.com/mosra/corrade/archive/b2be50eb3d514520b15640d7514a3441adb4bcb8/corrade-b2be50eb3d514520b15640d7514a3441adb4bcb8.tar.gz :
  CHECKSUM(SHA256) this package     : caa4a5f100df2fa870124df3364a8e3781531d764f2b55a87970554c4ab9d8dc
  CHECKSUM(SHA256) upstream package : caa4a5f100df2fa870124df3364a8e3781531d764f2b55a87970554c4ab9d8dc


Requires
--------
corrade (rpmlib, GLIBC filtered):
    ld-linux-x86-64.so.2()(64bit)
    libCorradeUtility.so.2()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.5)(64bit)
    libstdc++.so.6(CXXABI_1.3.8)(64bit)
    rtld(GNU_HASH)

corrade-devel (rpmlib, GLIBC filtered):
    cmake-filesystem
    corrade(x86-64)
    libCorradeInterconnect.so.2()(64bit)
    libCorradePluginManager.so.2()(64bit)
    libCorradeTestSuite.so.2()(64bit)
    libCorradeUtility.so.2()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

corrade-debuginfo (rpmlib, GLIBC filtered):

corrade-debugsource (rpmlib, GLIBC filtered):



Provides
--------
corrade:
    corrade
    corrade(x86-64)
    libCorradeInterconnect.so.2()(64bit)
    libCorradePluginManager.so.2()(64bit)
    libCorradeTestSuite.so.2()(64bit)
    libCorradeUtility.so.2()(64bit)

corrade-devel:
    cmake(Corrade)
    cmake(corrade)
    corrade-devel
    corrade-devel(x86-64)

corrade-debuginfo:
    corrade-debuginfo
    corrade-debuginfo(x86-64)
    debuginfo(build-id)
    libCorradeInterconnect.so.2.4-2020.6-1.20230725gitb2be50e.fc40.x86_64.debug()(64bit)
    libCorradePluginManager.so.2.4-2020.6-1.20230725gitb2be50e.fc40.x86_64.debug()(64bit)
    libCorradeTestSuite.so.2.4-2020.6-1.20230725gitb2be50e.fc40.x86_64.debug()(64bit)
    libCorradeUtility.so.2.4-2020.6-1.20230725gitb2be50e.fc40.x86_64.debug()(64bit)

corrade-debugsource:
    corrade-debugsource
    corrade-debugsource(x86-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2226670
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Generic, Shell-api
Disabled plugins: Perl, fonts, Java, R, PHP, Ocaml, Haskell, Python, SugarActivity
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 2 Petr Menšík 2023-11-01 10:18:04 UTC
Found just a minor issue with unowned directories

%dir %{_datadir}/corrade/
%{_datadir}/corrade/debuggers/gdb/*.py

Above owns just %{_datadir}/corrade/ and %{_datadir}/corrade/debuggers/gdb/*.py files, but not directories in between.
Either add directories in between too:
%dir %{_datadir}/corrade/debuggers/
%dir %{_datadir}/corrade/debuggers/gdb/

Or use just add all files in the directory, without %dir:
%{_datadir}/corrade/

Comment 3 Petr Menšík 2023-11-01 10:37:41 UTC
It is great to have pretty printers for gdb. Have you considered placing them into /usr/share/gdb/python/corrade instead of custom location? What way they could be auto-loaded if devel package were present. Just "python import corrade" might activate them. With smart auto-load named script they could be activated just automatially when debugging corrade libraries.

I have found just matreshka-devel and gdb-exploitable provide code into it. Others place python scripts directly into /usr/share/gdb/auto-load directories. libstdc++ or mono-core packages provide something there, you may want to consult how to prepare auto-loaded pretty printers with your devel package.

More information about auto-loading: https://sourceware.org/gdb/current/onlinedocs/gdb.html/Auto_002dloading.html#Auto_002dloading

To install files there you would still have to own those directories:

%dir %{_datadir}/gdb
%dir %{_datadir}/gdb/python/
%dir %{_datadir}/gdb/auto-load/
# Import any content from corrade folder
%{_datadir}/gdb/python/corrade/

Comment 4 Felix Wang 2023-11-03 11:49:07 UTC
> It is great to have pretty printers for gdb. Have you considered placing them into /usr/share/gdb/python/corrade instead of custom location? What way they could be auto-loaded if devel package were present. Just "python import corrade" might activate them. With smart auto-load named script they could be activated just automatially when debugging corrade libraries.

Thank you for the time to review the package. I opened an issue on the upstream repository to discuss the details about where to put GDB script file. If you are available, you can give your opinions there, which I know a little about this.

Ref: https://github.com/mosra/corrade/issues/179

Comment 5 Felix Wang 2023-11-06 01:13:07 UTC
There are numerous tasks before publishing new release, see the issue of https://github.com/mosra/corrade/issues/177. So I make the package as git commit revision.

update with the issue about GDB python script files:
Spec URL: https://topazus.fedorapeople.org/rpms/corrade.spec
SRPM URL: https://topazus.fedorapeople.org/rpms/corrade-2020.6-1.20231103git4922edf.fc40.src.rpm